## cmus 2.0.3

=== Makefile ===
all: main plugins man

include config.mk
include scripts/lib.mk

CFLAGS	+= -I. -g

# programs {{{
cmus-y := \
	browser.o buffer.o cmdline.o cmus.o command_mode.o comment.o \
	db.o debug.o editable.o expr.o filters.o \
	format_print.o glob.o history.o http.o input.o \
	keys.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
	output.o pcm.o pl.o play_queue.o player.o \
	read_wrapper.o server.o search.o \
	search_mode.o spawn.o tabexp.o tabexp_file.o \
	track.o track_db.o track_info.o tree.o uchar.o ui_curses.o window.o \
	worker.o xstrjoin.o

$(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS)

cmus: $(cmus-y) file.o path.o prog.o xmalloc.o
	$(call cmd,ld,$(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm)

cmus-remote: main.o file.o path.o prog.o xmalloc.o
	$(call cmd,ld,)
# }}}

# input plugins {{{
flac-objs		:= flac.lo
mad-objs		:= id3.lo mad.lo nomad.lo utf8_encode.lo
modplug-objs		:= modplug.lo
mpc-objs		:= mpc.lo
vorbis-objs		:= vorbis.lo
wav-objs		:= wav.lo

ip-$(CONFIG_FLAC)	+= flac.so
ip-$(CONFIG_MAD)	+= mad.so
ip-$(CONFIG_MODPLUG)	+= modplug.so
ip-$(CONFIG_MPC)	+= mpc.so
ip-$(CONFIG_VORBIS)	+= vorbis.so
ip-$(CONFIG_WAV)	+= wav.so

$(flac-objs):		CFLAGS += $(FLAC_CFLAGS)
$(mad-objs):		CFLAGS += $(MAD_CFLAGS)
$(modplug-objs):	CFLAGS += $(MODPLUG_CFLAGS)
$(mpc-objs):		CFLAGS += $(MPC_CFLAGS)
$(vorbis-objs):		CFLAGS += $(VORBIS_CFLAGS)

flac.so: $(flac-objs)
	$(call cmd,ld_dl,$(FLAC_LIBS))

mad.so: $(mad-objs)
	$(call cmd,ld_dl,$(MAD_LIBS))

modplug.so: $(modplug-objs)
	$(call cmd,ld_dl,$(MODPLUG_LIBS))

mpc.so: $(mpc-objs)
	$(call cmd,ld_dl,$(MPC_LIBS))

vorbis.so: $(vorbis-objs)
	$(call cmd,ld_dl,$(VORBIS_LIBS))

wav.so: $(wav-objs)
	$(call cmd,ld_dl,)
# }}}

# output plugins {{{
alsa-objs		:= alsa.lo mixer_alsa.lo
arts-objs		:= arts.lo
oss-objs		:= oss.lo mixer_oss.lo
sun-objs		:= sun.lo mixer_sun.lo
ao-objs			:= ao.lo

op-$(CONFIG_ALSA)	+= alsa.so
op-$(CONFIG_ARTS)	+= arts.so
op-$(CONFIG_OSS)	+= oss.so
op-$(CONFIG_SUN)	+= sun.so
op-$(CONFIG_AO)		+= ao.so

$(alsa-objs): CFLAGS	+= $(ALSA_CFLAGS)
$(arts-objs): CFLAGS	+= $(ARTS_CFLAGS)
$(oss-objs):  CFLAGS	+= $(OSS_CFLAGS)
$(sun-objs):  CFLAGS	+= $(SUN_CFLAGS)
$(ao-objs):   CFLAGS	+= $(AO_CFLAGS)

alsa.so: $(alsa-objs)
	$(call cmd,ld_dl,$(ALSA_LIBS))

arts.so: $(arts-objs)
	$(call cmd,ld_dl,$(ARTS_LIBS))

oss.so: $(oss-objs)
	$(call cmd,ld_dl,$(OSS_LIBS))

sun.so: $(sun-objs)
	$(call cmd,ld_dl,$(SUN_LIBS))

ao.so: $(ao-objs)
	$(call cmd,ld_dl,$(AO_LIBS))
# }}}

# man {{{
man1	:= Doc/cmus.1 Doc/cmus-remote.1

$(man1): Doc/ttman

%.1: %.txt
	$(call cmd,ttman)

Doc/ttman: Doc/ttman.o
	$(call cmd,ld,)

quiet_cmd_ttman = MAN    $@
      cmd_ttman = Doc/ttman $< $@
# }}}

data		= $(wildcard data/*)

clean		+= *.o *.lo *.so cmus cmus-remote Doc/*.o Doc/ttman Doc/*.1
distclean	+= config.mk config/*.h tags

main: cmus cmus-remote
plugins: $(ip-y) $(op-y)
man: $(man1)

install-main: main
	$(INSTALL) -m755 $(bindir) cmus cmus-remote

install-plugins: plugins
	$(INSTALL) -m755 $(libdir)/cmus/ip $(ip-y)
	$(INSTALL) -m755 $(libdir)/cmus/op $(op-y)

install-data: man
	$(INSTALL) -m644 $(datadir)/cmus $(data)
	$(INSTALL) -m755 $(datadir)/doc/cmus/examples cmus-status-display
	$(INSTALL) -m644 $(mandir)/man1 $(man1)

install: all install-main install-plugins install-data

tags:
	exuberant-ctags *.[ch]

# generating tarball using GIT {{{
REV	= HEAD

# version from an annotated tag
_ver0	= $(shell git describe $(REV) 2>/dev/null)
# version from a plain tag
_ver1	= $(shell git describe --tags $(REV) 2>/dev/null)
# SHA1
_ver2	= $(shell git rev-parse --verify --short $(REV) 2>/dev/null)

TARNAME	= cmus-$(or $(_ver0),$(_ver1),g$(_ver2))

dist:
	@tarname=$(TARNAME);						\
	test "$(_ver2)" || { echo "No such revision $(REV)"; exit 1; };	\
	echo "   DIST   $$tarname.tar.bz2";				\
	git tar-tree $(REV) $$tarname | bzip2 -c -9 > $$tarname.tar.bz2

# }}}

.PHONY: all main plugins man dist tags
.PHONY: install install-main install-plugins install-man

## cmus 2.0.4

=== Makefile ===
--- 
+++ 
@@ -17,13 +17,13 @@
 	track.o track_db.o track_info.o tree.o uchar.o ui_curses.o window.o \
 	worker.o xstrjoin.o
 
-$(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS)
+$(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
 
 cmus: $(cmus-y) file.o path.o prog.o xmalloc.o
-	$(call cmd,ld,$(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm)
+	$(call cmd,ld,$(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS))
 
 cmus-remote: main.o file.o path.o prog.o xmalloc.o
-	$(call cmd,ld,)
+	$(call cmd,ld,$(COMPAT_LIBS))
 # }}}
 
 # input plugins {{{
@@ -158,7 +158,7 @@
 	@tarname=$(TARNAME);						\
 	test "$(_ver2)" || { echo "No such revision $(REV)"; exit 1; };	\
 	echo "   DIST   $$tarname.tar.bz2";				\
-	git tar-tree $(REV) $$tarname | bzip2 -c -9 > $$tarname.tar.bz2
+	git tar-tree $(REV)^{tree} $$tarname | bzip2 -c -9 > $$tarname.tar.bz2
 
 # }}}

## cmus 2.1.0

=== Makefile ===
--- 
+++ 
@@ -1,15 +1,25 @@
+VERSION = 2.1.0
+
 all: main plugins man
 
 include config.mk
 include scripts/lib.mk
 
-CFLAGS	+= -I. -g
+CFLAGS += -D_FILE_OFFSET_BITS=64
+
+input.o main.o ui_curses.o: .version
+input.o main.o ui_curses.o: CFLAGS += -DVERSION=\"$(VERSION)\"
+main.o server.o: CFLAGS += -DDEFAULT_PORT=3000
+
+.version: Makefile
+	@test "`cat $@ 2> /dev/null`" = "$(VERSION)" && exit 0; \
+	echo "   GEN    $@"; echo $(VERSION) > $@
 
 # programs {{{
 cmus-y := \
 	browser.o buffer.o cmdline.o cmus.o command_mode.o comment.o \
 	db.o debug.o editable.o expr.o filters.o \
-	format_print.o glob.o history.o http.o input.o \
+	format_print.o glob.o help.o history.o http.o input.o \
 	keys.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
 	read_wrapper.o server.o search.o \
@@ -29,29 +39,41 @@
 # input plugins {{{
 flac-objs		:= flac.lo
 mad-objs		:= id3.lo mad.lo nomad.lo utf8_encode.lo
+mikmod-objs		:= mikmod.lo
 modplug-objs		:= modplug.lo
 mpc-objs		:= mpc.lo
 vorbis-objs		:= vorbis.lo
 wav-objs		:= wav.lo
+mp4-objs		:= mp4.lo
+aac-objs		:= id3.lo utf8_encode.lo aac.lo
 
 ip-$(CONFIG_FLAC)	+= flac.so
 ip-$(CONFIG_MAD)	+= mad.so
+ip-$(CONFIG_MIKMOD)	+= mikmod.so
 ip-$(CONFIG_MODPLUG)	+= modplug.so
 ip-$(CONFIG_MPC)	+= mpc.so
 ip-$(CONFIG_VORBIS)	+= vorbis.so
 ip-$(CONFIG_WAV)	+= wav.so
+ip-$(CONFIG_MP4)	+= mp4.so
+ip-$(CONFIG_AAC)	+= aac.so
 
 $(flac-objs):		CFLAGS += $(FLAC_CFLAGS)
 $(mad-objs):		CFLAGS += $(MAD_CFLAGS)
+$(mikmod-objs):		CFLAGS += $(MIKMOD_CFLAGS)
 $(modplug-objs):	CFLAGS += $(MODPLUG_CFLAGS)
 $(mpc-objs):		CFLAGS += $(MPC_CFLAGS)
 $(vorbis-objs):		CFLAGS += $(VORBIS_CFLAGS)
+$(mp4-objs):		CFLAGS += $(MP4_CFLAGS)
+$(aac-objs):		CFLAGS += $(AAC_CFLAGS)
 
 flac.so: $(flac-objs)
 	$(call cmd,ld_dl,$(FLAC_LIBS))
 
 mad.so: $(mad-objs)
 	$(call cmd,ld_dl,$(MAD_LIBS))
+
+mikmod.so: $(mikmod-objs)
+	$(call cmd,ld_dl,$(MIKMOD_LIBS))
 
 modplug.so: $(modplug-objs)
 	$(call cmd,ld_dl,$(MODPLUG_LIBS))
@@ -64,6 +86,13 @@
 
 wav.so: $(wav-objs)
 	$(call cmd,ld_dl,)
+
+mp4.so: $(mp4-objs)
+	$(call cmd,ld_dl,$(MP4_LIBS))
+
+aac.so: $(aac-objs)
+	$(call cmd,ld_dl,$(AAC_LIBS))
+
 # }}}
 
 # output plugins {{{
@@ -119,7 +148,7 @@
 data		= $(wildcard data/*)
 
 clean		+= *.o *.lo *.so cmus cmus-remote Doc/*.o Doc/ttman Doc/*.1
-distclean	+= config.mk config/*.h tags
+distclean	+= .version config.mk config/*.h tags
 
 main: cmus cmus-remote
 plugins: $(ip-y) $(op-y)
@@ -158,7 +187,7 @@
 	@tarname=$(TARNAME);						\
 	test "$(_ver2)" || { echo "No such revision $(REV)"; exit 1; };	\
 	echo "   DIST   $$tarname.tar.bz2";				\
-	git tar-tree $(REV)^{tree} $$tarname | bzip2 -c -9 > $$tarname.tar.bz2
+	git archive --format=tar --prefix=$$tarname/ $(REV)^{tree} | bzip2 -c -9 > $$tarname.tar.bz2
 
 # }}}

## cmus 2.2.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION = 2.1.0
+VERSION = 2.2.0
 
 all: main plugins man
 
@@ -6,6 +6,8 @@
 include scripts/lib.mk
 
 CFLAGS += -D_FILE_OFFSET_BITS=64
+
+CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS)
 
 input.o main.o ui_curses.o: .version
 input.o main.o ui_curses.o: CFLAGS += -DVERSION=\"$(VERSION)\"
@@ -17,35 +19,50 @@
 
 # programs {{{
 cmus-y := \
-	browser.o buffer.o cmdline.o cmus.o command_mode.o comment.o \
+	ape.o browser.o buffer.o cmdline.o cmus.o command_mode.o comment.o \
 	db.o debug.o editable.o expr.o filters.o \
-	format_print.o glob.o help.o history.o http.o input.o \
+	format_print.o glob.o help.o history.o http.o id3.o input.o \
 	keys.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
 	read_wrapper.o server.o search.o \
 	search_mode.o spawn.o tabexp.o tabexp_file.o \
-	track.o track_db.o track_info.o tree.o uchar.o ui_curses.o window.o \
-	worker.o xstrjoin.o
+	track.o track_db.o track_info.o tree.o uchar.o ui_curses.o \
+	utf8_encode.lo window.o worker.o xstrjoin.o
 
 $(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
 
 cmus: $(cmus-y) file.o path.o prog.o xmalloc.o
-	$(call cmd,ld,$(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS))
+	$(call cmd,ld,$(CMUS_LIBS))
 
 cmus-remote: main.o file.o path.o prog.o xmalloc.o
 	$(call cmd,ld,$(COMPAT_LIBS))
+
+# cygwin compat
+DLLTOOL=dlltool
+
+libcmus-$(CONFIG_CYGWIN) := libcmus.a
+
+libcmus.a: $(cmus-y) file.o path.o prog.o xmalloc.o
+	$(LD) -shared -o cmus.exe -Wl,--out-implib=libcmus.a -Wl,--base-file,cmus.base \
+		-Wl,--export-all-symbols -Wl,--no-whole-archive $^ $(CMUS_LIBS)
+	$(DLLTOOL) --output-def cmus.def --dllname cmus.exe --export-all-symbols $^
+	$(DLLTOOL) --base-file cmus.base --dllname cmus.exe --input-def cmus.def --output-exp cmus.exp
+	$(LD) -o cmus.exe -Wl,cmus.exp $^ $(CMUS_LIBS)
+
 # }}}
 
 # input plugins {{{
 flac-objs		:= flac.lo
-mad-objs		:= id3.lo mad.lo nomad.lo utf8_encode.lo
+mad-objs		:= mad.lo nomad.lo
 mikmod-objs		:= mikmod.lo
 modplug-objs		:= modplug.lo
 mpc-objs		:= mpc.lo
 vorbis-objs		:= vorbis.lo
+wavpack-objs		:= wavpack.lo
 wav-objs		:= wav.lo
 mp4-objs		:= mp4.lo
-aac-objs		:= id3.lo utf8_encode.lo aac.lo
+aac-objs		:= aac.lo
+ffmpeg-objs		:= ffmpeg.lo
 
 ip-$(CONFIG_FLAC)	+= flac.so
 ip-$(CONFIG_MAD)	+= mad.so
@@ -53,9 +70,11 @@
 ip-$(CONFIG_MODPLUG)	+= modplug.so
 ip-$(CONFIG_MPC)	+= mpc.so
 ip-$(CONFIG_VORBIS)	+= vorbis.so
+ip-$(CONFIG_WAVPACK)	+= wavpack.so
 ip-$(CONFIG_WAV)	+= wav.so
 ip-$(CONFIG_MP4)	+= mp4.so
 ip-$(CONFIG_AAC)	+= aac.so
+ip-$(CONFIG_FFMPEG)	+= ffmpeg.so
 
 $(flac-objs):		CFLAGS += $(FLAC_CFLAGS)
 $(mad-objs):		CFLAGS += $(MAD_CFLAGS)
@@ -63,35 +82,43 @@
 $(modplug-objs):	CFLAGS += $(MODPLUG_CFLAGS)
 $(mpc-objs):		CFLAGS += $(MPC_CFLAGS)
 $(vorbis-objs):		CFLAGS += $(VORBIS_CFLAGS)
+$(wavpack-objs):	CFLAGS += $(WAVPACK_CFLAGS)
 $(mp4-objs):		CFLAGS += $(MP4_CFLAGS)
 $(aac-objs):		CFLAGS += $(AAC_CFLAGS)
-
-flac.so: $(flac-objs)
+$(ffmpeg-objs):		CFLAGS += $(FFMPEG_CFLAGS)
+
+flac.so: $(flac-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(FLAC_LIBS))
 
-mad.so: $(mad-objs)
-	$(call cmd,ld_dl,$(MAD_LIBS))
-
-mikmod.so: $(mikmod-objs)
+mad.so: $(mad-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(MAD_LIBS) $(ICONV_LIBS))
+
+mikmod.so: $(mikmod-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(MIKMOD_LIBS))
 
-modplug.so: $(modplug-objs)
+modplug.so: $(modplug-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(MODPLUG_LIBS))
 
-mpc.so: $(mpc-objs)
+mpc.so: $(mpc-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(MPC_LIBS))
 
-vorbis.so: $(vorbis-objs)
+vorbis.so: $(vorbis-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(VORBIS_LIBS))
 
-wav.so: $(wav-objs)
+wavpack.so: $(wavpack-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(WAVPACK_LIBS))
+
+wav.so: $(wav-objs) $(libcmus-y)
 	$(call cmd,ld_dl,)
 
-mp4.so: $(mp4-objs)
+mp4.so: $(mp4-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(MP4_LIBS))
 
-aac.so: $(aac-objs)
+aac.so: $(aac-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(AAC_LIBS))
+
+ffmpeg.so: $(ffmpeg-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(FFMPEG_LIBS))
 
 # }}}
 
@@ -101,33 +128,39 @@
 oss-objs		:= oss.lo mixer_oss.lo
 sun-objs		:= sun.lo mixer_sun.lo
 ao-objs			:= ao.lo
+waveout-objs		:= waveout.lo
 
 op-$(CONFIG_ALSA)	+= alsa.so
 op-$(CONFIG_ARTS)	+= arts.so
 op-$(CONFIG_OSS)	+= oss.so
 op-$(CONFIG_SUN)	+= sun.so
 op-$(CONFIG_AO)		+= ao.so
+op-$(CONFIG_WAVEOUT)	+= waveout.so
 
 $(alsa-objs): CFLAGS	+= $(ALSA_CFLAGS)
 $(arts-objs): CFLAGS	+= $(ARTS_CFLAGS)
 $(oss-objs):  CFLAGS	+= $(OSS_CFLAGS)
 $(sun-objs):  CFLAGS	+= $(SUN_CFLAGS)
 $(ao-objs):   CFLAGS	+= $(AO_CFLAGS)
-
-alsa.so: $(alsa-objs)
+$(waveout-objs): CFLAGS += $(WAVEOUT_CFLAGS)
+
+alsa.so: $(alsa-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(ALSA_LIBS))
 
-arts.so: $(arts-objs)
+arts.so: $(arts-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(ARTS_LIBS))
 
-oss.so: $(oss-objs)
+oss.so: $(oss-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(OSS_LIBS))
 
-sun.so: $(sun-objs)
+sun.so: $(sun-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(SUN_LIBS))
 
-ao.so: $(ao-objs)
+ao.so: $(ao-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(AO_LIBS))
+
+waveout.so: $(waveout-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(WAVEOUT_LIBS))
 # }}}
 
 # man {{{
@@ -147,7 +180,7 @@
 
 data		= $(wildcard data/*)
 
-clean		+= *.o *.lo *.so cmus cmus-remote Doc/*.o Doc/ttman Doc/*.1
+clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1
 distclean	+= .version config.mk config/*.h tags
 
 main: cmus cmus-remote
@@ -163,8 +196,8 @@
 
 install-data: man
 	$(INSTALL) -m644 $(datadir)/cmus $(data)
-	$(INSTALL) -m755 $(datadir)/doc/cmus/examples cmus-status-display
 	$(INSTALL) -m644 $(mandir)/man1 $(man1)
+	$(INSTALL) -m755 $(exampledir) cmus-status-display
 
 install: all install-main install-plugins install-data

## cmus 2.3.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,15 @@
-VERSION = 2.2.0
+REV	= HEAD
+
+# version from an annotated tag
+_ver0	= $(shell git describe $(REV) 2>/dev/null)
+# version from a plain tag
+_ver1	= $(shell git describe --tags $(REV) 2>/dev/null)
+# SHA1
+_ver2	= $(shell git rev-parse --verify --short $(REV) 2>/dev/null)
+# hand-made
+_ver3	= v2.3.3
+
+VERSION	= $(or $(_ver0),$(_ver1),$(_ver2),$(_ver3))
 
 all: main plugins man
 
@@ -9,8 +20,8 @@
 
 CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS)
 
-input.o main.o ui_curses.o: .version
-input.o main.o ui_curses.o: CFLAGS += -DVERSION=\"$(VERSION)\"
+input.o main.o ui_curses.o pulse.lo: .version
+input.o main.o ui_curses.o pulse.lo: CFLAGS += -DVERSION=\"$(VERSION)\"
 main.o server.o: CFLAGS += -DDEFAULT_PORT=3000
 
 .version: Makefile
@@ -19,14 +30,14 @@
 
 # programs {{{
 cmus-y := \
-	ape.o browser.o buffer.o cmdline.o cmus.o command_mode.o comment.o \
-	db.o debug.o editable.o expr.o filters.o \
-	format_print.o glob.o help.o history.o http.o id3.o input.o \
-	keys.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
+	ape.o browser.o buffer.o cache.o cmdline.o cmus.o command_mode.o comment.o \
+	debug.o editable.o expr.o filters.o \
+	format_print.o gbuf.o glob.o help.o history.o http.o id3.o input.o job.o \
+	keys.o keyval.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
 	read_wrapper.o server.o search.o \
 	search_mode.o spawn.o tabexp.o tabexp_file.o \
-	track.o track_db.o track_info.o tree.o uchar.o ui_curses.o \
+	track.o track_info.o tree.o uchar.o ui_curses.o \
 	utf8_encode.lo window.o worker.o xstrjoin.o
 
 $(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
@@ -123,6 +134,7 @@
 # }}}
 
 # output plugins {{{
+pulse-objs		:= pulse.lo
 alsa-objs		:= alsa.lo mixer_alsa.lo
 arts-objs		:= arts.lo
 oss-objs		:= oss.lo mixer_oss.lo
@@ -130,6 +142,7 @@
 ao-objs			:= ao.lo
 waveout-objs		:= waveout.lo
 
+op-$(CONFIG_PULSE)	+= pulse.so
 op-$(CONFIG_ALSA)	+= alsa.so
 op-$(CONFIG_ARTS)	+= arts.so
 op-$(CONFIG_OSS)	+= oss.so
@@ -137,6 +150,7 @@
 op-$(CONFIG_AO)		+= ao.so
 op-$(CONFIG_WAVEOUT)	+= waveout.so
 
+$(pulse-objs): CFLAGS	+= $(PULSE_CFLAGS)
 $(alsa-objs): CFLAGS	+= $(ALSA_CFLAGS)
 $(arts-objs): CFLAGS	+= $(ARTS_CFLAGS)
 $(oss-objs):  CFLAGS	+= $(OSS_CFLAGS)
@@ -144,6 +158,9 @@
 $(ao-objs):   CFLAGS	+= $(AO_CFLAGS)
 $(waveout-objs): CFLAGS += $(WAVEOUT_CFLAGS)
 
+pulse.so: $(pulse-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(PULSE_LIBS))
+
 alsa.so: $(alsa-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(ALSA_LIBS))
 
@@ -165,12 +182,17 @@
 
 # man {{{
 man1	:= Doc/cmus.1 Doc/cmus-remote.1
+man7	:= Doc/cmus-tutorial.7
 
 $(man1): Doc/ttman
+$(man7): Doc/ttman
 
 %.1: %.txt
 	$(call cmd,ttman)
 
+%.7: %.txt
+	$(call cmd,ttman)
+
 Doc/ttman: Doc/ttman.o
 	$(call cmd,ld,)
 
@@ -180,12 +202,12 @@
 
 data		= $(wildcard data/*)
 
-clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1
+clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1 Doc/*.7
 distclean	+= .version config.mk config/*.h tags
 
 main: cmus cmus-remote
 plugins: $(ip-y) $(op-y)
-man: $(man1)
+man: $(man1) $(man7)
 
 install-main: main
 	$(INSTALL) -m755 $(bindir) cmus cmus-remote
@@ -197,6 +219,7 @@
 install-data: man
 	$(INSTALL) -m644 $(datadir)/cmus $(data)
 	$(INSTALL) -m644 $(mandir)/man1 $(man1)
+	$(INSTALL) -m644 $(mandir)/man7 $(man7)
 	$(INSTALL) -m755 $(exampledir) cmus-status-display
 
 install: all install-main install-plugins install-data
@@ -205,16 +228,7 @@
 	exuberant-ctags *.[ch]
 
 # generating tarball using GIT {{{
-REV	= HEAD
-
-# version from an annotated tag
-_ver0	= $(shell git describe $(REV) 2>/dev/null)
-# version from a plain tag
-_ver1	= $(shell git describe --tags $(REV) 2>/dev/null)
-# SHA1
-_ver2	= $(shell git rev-parse --verify --short $(REV) 2>/dev/null)
-
-TARNAME	= cmus-$(or $(_ver0),$(_ver1),g$(_ver2))
+TARNAME	= cmus-$(VERSION)
 
 dist:
 	@tarname=$(TARNAME);						\

=== debian/changelog ===
cmus (2.3.3-2build1) maverick; urgency=low

  * No changes upload for libmodplug0c2 -> libmodplug1 transition

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Wed, 15 Sep 2010 20:14:47 +0200

cmus (2.3.3-2) unstable; urgency=low

  * Prevent terminal corruption on track change.
  * debian/copyright: Update sources download location.
  * Split cmus to provide smart dependencies (Closes: #442423).
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Sun, 01 Aug 2010 12:26:08 +0200

cmus (2.3.3-1) unstable; urgency=low

  [ Ryan Kavanagh ]
  * New upstream release (Closes: #572284)
  * Imported Upstream version 2.3.3
  * Changed to source format 3.0 source. Involved converting
    dpatch->quilt and dropping dpatch B-D.
  * Dropped 01_cmusffmpeg.diff, no longer needed. Upstream checks for
    ffmpeg and falls back to libavcodec for us.
  * Dropped 02_cmusstatusdisplay.diff, included upstream.
  * Dropped Yavor's mpcdec patch. Upstream expanded on it, using his
    code if building under MPC SV8, the old code otherwise.
  * Updated debian/watch
  * Updated copyright file with new copyright holders and download
    location.
  * This is a new upload, package will thus be rebuilt against libavformat.
    (Closes: #568361).
  * Dropped debian/patches directory
  * Move to debhelper 7 rules
  * Now standards-version 3.8.4
  * Fix debhelper-but-no-misc-depends lintian warning
  * Override dh_auto_configure because upstream uses a homebrewed configure
    script that doesn't accept --a=b style options
  * Bump debhelper version to (>= 7.0.50~) because we're using override_dh_*
  * Fix spelling mistakes in binary and documentation
    (01_spelling_mistake.diff)
  * Fix whatis entry for cmus-tutorial manpage (02_cmus-tutorial_whatis.diff)
  * Added Julien Louis' and my own packaging copyright blurb to
    debian/copyright. 

  [ Alessio Treglia ]
  * This isn't a non-maintainer upload, we adopt this (Closes: #587604).
  * Add debian/gbp.conf file.
  * debian/control:
    - Add Vcs-* tags.
    - Bump Standards.
    - Lines should be shorter than 80 characters.
    - Add myself to Uploaders field, I'll take care of sponsoring this in
      future.
    - Build-depend on pkg-config.
    - Drop unnecessary Recommends field.
  * Drop aRTs support as it is no longer maintained.
  * Add PulseAudio support.
  * debian/rules:
    - Call configure script instead of relying on dh_auto_configure.
  * Drop README.source, we don't rely on dpatch as patch system.
  * Update debian/copyright.

 -- Alessio Treglia <alessio@debian.org>  Sun, 04 Jul 2010 20:06:58 +0200

cmus (2.2.0-4.1) unstable; urgency=low

  * NMU
  * Patch from Yavor Doganov to port cmus to the new mpcdec API,
    thereby allowing cmus to build from source again.
    closes: #476382, #552820.

 -- Clint Adams <schizo@debian.org>  Sun, 31 Jan 2010 00:03:40 -0500

cmus (2.2.0-4) unstable; urgency=low

  * Updated debian/watch file Closes: #449897
    - Thanks to Raphael Geissert <atomo64@gmail.com>
  * Fix the ffmpeg/avcodec.h includes Closes: #517570
    - Thanks to Cyril Brulebois <kibi@debian.org>
  * Added Recommends libasound2, libartsc0, libao2 Closes: #439719
  * Added Depends line in debian/control
  * Added dpatch on Build-Depends on debian/control
  * Deleted commented lines on debian/rules
  * Update debian/rules for dpatch dependence
  * Changed debian/control
    - Standard-Version to 3.8.1 ( was 3.8.0 )
    - Added debian/README.source
    - Updated to debhelper to 7
    - Updated debian/compat (was 5)
    - Added Homepage field

 -- Carlos Eduardo Sotelo Pinto (krlos) <krlos.aqp@gmail.com>  Thu, 19 Mar 2009 13:38:16 -0500

cmus (2.2.0-3) unstable; urgency=low

  * Acknowledging NMU.  Closes: #509277.

 -- Carlos Eduardo Sotelo Pinto (krlos) <krlos.aqp@gmail.com>  Mon, 29 Dec 2008 22:01:01 +0100

cmus (2.2.0-2) unstable; urgency=low

  * New maintainer. Closes: #484734
  * Changed debian/control
    - Standard-Version to 3.8.0 ( was 3.7.2 no changes needed )

 -- Carlos Eduardo Sotelo Pinto (krlos) <krlos.aqp@gmail.com>  Wed, 03 Sep 2008 17:46:50 -0500

cmus (2.2.0-1.1) unstable; urgency=high

  * Non-maintainer upload by the Security Team.
  * Modify example script cmus-status-display to write the current
    status to .cmus-status in the user's home instead of /tmp/cmus-status,
    since the latter could lead to symlink attacks. CVE-2008-5375
    (Closes: #509277)

 -- Moritz Muehlenhoff <jmm@debian.org>  Sun, 28 Dec 2008 14:57:06 +0100

cmus (2.2.0-1) unstable; urgency=low

  * New upstream release
  * Add libwavpack-dev and libavformat.dev to Build-Depends
  * Update debian/copyright

 -- Julien Louis <ptitlouis@sysif.net>  Fri, 27 Jul 2007 21:54:36 +0200

cmus (2.1.0-2) unstable; urgency=low

  * Rebuild against libflac8 (Closes: #426638).

 -- Julien Louis <ptitlouis@sysif.net>  Mon, 04 Jun 2007 22:56:58 +0200

cmus (2.1.0-1) unstable; urgency=low

  * New upstream release (closes: #399965).
  * Updated debian/copyright
  * Added libfaad-dev to Build-Depends

 -- Julien Louis <ptitlouis@sysif.net>  Thu, 21 Dec 2006 20:25:59 +0100

cmus (2.0.4-1) unstable; urgency=low

  * New upstream release.
  * Added debian/watch file.
  * Build-Depends agains libasound2-dev (>= 1.0.11).

 -- Julien Louis <ptitlouis@sysif.net>  Wed, 23 Aug 2006 03:34:04 +0200

cmus (2.0.3-3) unstable; urgency=low

  * Drop libasound2-dev Build Dependency on non-linux arches
    (Closes: #377885).

 -- Julien Louis <ptitlouis@sysif.net>  Wed, 12 Jul 2006 01:06:02 +0200

cmus (2.0.3-2) unstable; urgency=low

  * Move all dh_* helper stuff in the binary-arch target (Closes: #376320).
  * Remove debian/patches/01_asciidoc_xsl_path.dpatch since it is not usefull.
  * Remove dpatch from Build-Depends.

 -- Julien Louis <ptitlouis@sysif.net>  Sun,  2 Jul 2006 14:16:03 +0200

cmus (2.0.3-1) unstable; urgency=low

  * New upstream release.
  * Remove asciidoc, docbook-xsl, doxbook-xml ans xsltproc from Build-Depends.


=== debian/control ===
Source: cmus
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>,
 Ryan Kavanagh <ryanakca@kubuntu.org>
Build-Depends: debhelper (>= 7.0.50~),
 pkg-config,
 libflac-dev,
 libncursesw5-dev,
 libmodplug-dev,
 libmad0-dev,
 libvorbis-dev,
 libpulse-dev (>= 0.9.19),
 libasound2-dev (>= 1.0.11) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libmpcdec-dev,
 libao-dev,
 libfaad-dev,
 libwavpack-dev,
 libavformat-dev
Standards-Version: 3.9.1
Homepage: http://cmus.sourceforge.net/
Vcs-Git: git://git.debian.org/pkg-multimedia/cmus.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/cmus.git

Package: cmus
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: cmus-plugin-ffmpeg
Description: lightweight ncurses audio player
 C* Music Player is a modular and very configurable ncurses-based audio player.
 It has some interesting features like configurable colorscheme, mp3 and ogg
 streaming, it can be controlled with an UNIX socket, filters, album/artists
 sorting and a vi-like configuration interface. 
 .
 It currently supports different input formats:
  - Ogg Vorbis
  - MP3 (with libmad)
  - FLAC
  - Wav
  - Modules (with libmodplug)
  - Musepack
  - AAC
  - Windows Media Audio

Package: cmus-plugin-ffmpeg
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: cmus
Description: lightweight ncurses audio player (FFmpeg plugin)
 C* Music Player is a modular and very configurable ncurses-based audio player.
 It has some interesting features like configurable colorscheme, mp3 and ogg
 streaming, it can be controlled with an UNIX socket, filters, album/artists
 sorting and a vi-like configuration interface.
 .
 This package adds FFmpeg support to C* Music Player.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

LDFLAGS+=-Wl,--as-needed
CFLAGS+=-I/usr/include/ncursesw

%:
	dh $@

override_dh_auto_configure:
	./configure \
		prefix=/usr \
		CONFIG_ARTS=n \
		DEBUG=0

override_dh_install:
	dh_install -pcmus
	dh_movefiles -pcmus-plugin-ffmpeg --sourcedir=debian/cmus/ \
		/usr/lib/cmus/ip/ffmpeg.so

=== debian/watch ===
version=3
http://sf.net/cmus/cmus-v(.*)\.tar\.bz2

## cmus 2.4.0

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # SHA1
 _ver2	= $(shell git rev-parse --verify --short $(REV) 2>/dev/null)
 # hand-made
-_ver3	= v2.3.3
+_ver3	= v2.4.0
 
 VERSION	= $(or $(_ver0),$(_ver1),$(_ver2),$(_ver3))
 
@@ -31,14 +31,14 @@
 # programs {{{
 cmus-y := \
 	ape.o browser.o buffer.o cache.o cmdline.o cmus.o command_mode.o comment.o \
-	debug.o editable.o expr.o filters.o \
+	convert.lo debug.o editable.o expr.o filters.o \
 	format_print.o gbuf.o glob.o help.o history.o http.o id3.o input.o job.o \
 	keys.o keyval.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
-	read_wrapper.o server.o search.o \
+	rbtree.o read_wrapper.o server.o search.o \
 	search_mode.o spawn.o tabexp.o tabexp_file.o \
-	track.o track_info.o tree.o uchar.o ui_curses.o \
-	utf8_encode.lo window.o worker.o xstrjoin.o
+	track.o track_info.o tree.o u_collate.o uchar.o ui_curses.o \
+	window.o worker.o xstrjoin.o
 
 $(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
 
@@ -141,6 +141,7 @@
 sun-objs		:= sun.lo mixer_sun.lo
 ao-objs			:= ao.lo
 waveout-objs		:= waveout.lo
+roar-objs               := roar.lo
 
 op-$(CONFIG_PULSE)	+= pulse.so
 op-$(CONFIG_ALSA)	+= alsa.so
@@ -149,6 +150,7 @@
 op-$(CONFIG_SUN)	+= sun.so
 op-$(CONFIG_AO)		+= ao.so
 op-$(CONFIG_WAVEOUT)	+= waveout.so
+op-$(CONFIG_ROAR)       += roar.so
 
 $(pulse-objs): CFLAGS	+= $(PULSE_CFLAGS)
 $(alsa-objs): CFLAGS	+= $(ALSA_CFLAGS)
@@ -157,6 +159,7 @@
 $(sun-objs):  CFLAGS	+= $(SUN_CFLAGS)
 $(ao-objs):   CFLAGS	+= $(AO_CFLAGS)
 $(waveout-objs): CFLAGS += $(WAVEOUT_CFLAGS)
+$(roar-objs): CFLAGS	+= $(ROAR_CFLAGS)
 
 pulse.so: $(pulse-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(PULSE_LIBS))
@@ -178,6 +181,9 @@
 
 waveout.so: $(waveout-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(WAVEOUT_LIBS))
+
+roar.so: $(roar-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(ROAR_LIBS))
 # }}}
 
 # man {{{
@@ -193,8 +199,11 @@
 %.7: %.txt
 	$(call cmd,ttman)
 
+Doc/ttman.o: Doc/ttman.c
+	$(call cmd,hostcc,)
+
 Doc/ttman: Doc/ttman.o
-	$(call cmd,ld,)
+	$(call cmd,hostld,)
 
 quiet_cmd_ttman = MAN    $@
       cmd_ttman = Doc/ttman $< $@

=== debian/changelog ===
cmus (2.4.0-1) unstable; urgency=low

  * New upstream release "Easter egg":
    - Mutt-like short filters.
    - Live filtering.
    - Resume support.
    - Smarter string handling.
    - Long format options, including ones for bitrate/codec.
    - HTTP proxy support for streams via http_proxy environment variable.
    - Less CPU wakeups during playback.
    - New RoarAudio output plugin.
    - Support for big-endian systems, lots of different audio sample formats,
      almost any C compiler and unix-like OS out there.
    - Various bugfixes.
    - Full release notes are available at:
      http://sourceforge.net/mailarchive/message.php?msg_id=27403242
  * debian/watch: Properly handle release-candidate,beta releases.
  * Remove debian/patches directory, all patches have been applied upstream.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Tue, 26 Apr 2011 23:30:07 +0200

cmus (2.3.5-1) unstable; urgency=low

  * New upstream release:
    - Features gapless MP3 playback.
    - Native PulseAudio support.
    - Faster startup.
    - Improve buildsystem.
  * Refresh patches.
  * Remo 21-missing_plugins.patch, applied upstream.

 -- Alessio Treglia <alessio@debian.org>  Sat, 23 Apr 2011 09:56:57 +0200

cmus (2.3.4-3) unstable; urgency=low

  * Handle missing dependencies more gracefully:
    - cmus silently skips plugins with missing dependencies, and instead
      outputs a debug message. Original patch by Johannes Weißl, already
      accepted upstream.

 -- Alessio Treglia <alessio@debian.org>  Fri, 01 Apr 2011 08:59:01 +0200

cmus (2.3.4-2) unstable; urgency=low

  * Avoid to depend on several sound servers (Closes: #612887) and let
    users choose to rely on the favorite one.
    - debian/control:
      + Add shlibs:Recommends field.
    - debian/rules:
      + Supply {dh_,dpkg-}shlibdeps with proper options to demote roar
        and pulse audio dependencies to Recommends.

 -- Alessio Treglia <alessio@debian.org>  Tue, 15 Mar 2011 12:46:03 +0100

cmus (2.3.4-1) unstable; urgency=low

  [ Ryan Kavanagh ]
  * New upstream release.
  * Dropped 01_spelling_mistakes.diff, 02_cmus-tutorial_whatis.diff
    and 03-terminal_corruption.patch (applied upstream).
  * Refreshed 10-roaraudio_support.patch
  * Bump my copyright

  [ Alessio Treglia ]
  * Add DM-Upload-Allowed: yes.

 -- Ryan Kavanagh <ryanakca@kubuntu.org>  Tue, 22 Feb 2011 09:03:23 -0500

cmus (2.3.3-4) unstable; urgency=low

  * Upload to unstable.

 -- Alessio Treglia <alessio@debian.org>  Wed, 09 Feb 2011 12:05:49 +0100

cmus (2.3.3-3) experimental; urgency=low

  * Add RoarOutput plugin (Closes: #609202), thanks to
    Philipp Schafft <lion@lion.leolix.org> for the patch.
  * Add patch taken from upstream's git to fix segfault when adding to
    queue.
  * Build-depends on libroar-dev (>= 0.4~beta2).

 -- Alessio Treglia <alessio@debian.org>  Mon, 17 Jan 2011 02:23:04 +0100

=== debian/control ===
--- 
+++ 
@@ -16,9 +16,11 @@
  libmpcdec-dev,
  libao-dev,
  libfaad-dev,
+ libroar-dev (>= 0.4~beta2),
  libwavpack-dev,
  libavformat-dev
-Standards-Version: 3.9.1
+DM-Upload-Allowed: yes
+Standards-Version: 3.9.2
 Homepage: http://cmus.sourceforge.net/
 Vcs-Git: git://git.debian.org/pkg-multimedia/cmus.git
 Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/cmus.git
@@ -27,7 +29,8 @@
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-Recommends: cmus-plugin-ffmpeg
+Recommends: cmus-plugin-ffmpeg,
+ ${shlibs:Recommends}
 Description: lightweight ncurses audio player
  C* Music Player is a modular and very configurable ncurses-based audio player.
  It has some interesting features like configurable colorscheme, mp3 and ogg

## cmus 2.4.0-1

=== Makefile ===
--- 
+++ 
@@ -18,11 +18,13 @@
 
 CFLAGS += -D_FILE_OFFSET_BITS=64
 
-CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS)
+CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) $(DISCID_LIBS) $(CUE_LIBS) -lm $(COMPAT_LIBS)
 
 input.o main.o ui_curses.o pulse.lo: .version
 input.o main.o ui_curses.o pulse.lo: CFLAGS += -DVERSION=\"$(VERSION)\"
 main.o server.o: CFLAGS += -DDEFAULT_PORT=3000
+discid.o: CFLAGS += $(DISCID_CFLAGS)
+job.o cue_utils.o: CFLAGS += $(CUE_CFLAGS)
 
 .version: Makefile
 	@test "`cat $@ 2> /dev/null`" = "$(VERSION)" && exit 0; \
@@ -31,7 +33,7 @@
 # programs {{{
 cmus-y := \
 	ape.o browser.o buffer.o cache.o cmdline.o cmus.o command_mode.o comment.o \
-	convert.lo debug.o editable.o expr.o filters.o \
+	channelmap.o convert.lo debug.o discid.o editable.o expr.o filters.o \
 	format_print.o gbuf.o glob.o help.o history.o http.o id3.o input.o job.o \
 	keys.o keyval.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
@@ -40,6 +42,8 @@
 	track.o track_info.o tree.o u_collate.o uchar.o ui_curses.o \
 	window.o worker.o xstrjoin.o
 
+cmus-$(CONFIG_CUE) += cue_utils.o
+
 $(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
 
 cmus: $(cmus-y) file.o path.o prog.o xmalloc.o
@@ -63,6 +67,7 @@
 # }}}
 
 # input plugins {{{
+cdio-objs		:= cdio.lo
 flac-objs		:= flac.lo
 mad-objs		:= mad.lo nomad.lo
 mikmod-objs		:= mikmod.lo
@@ -74,7 +79,9 @@
 mp4-objs		:= mp4.lo
 aac-objs		:= aac.lo
 ffmpeg-objs		:= ffmpeg.lo
-
+cue-objs		:= cue.lo
+
+ip-$(CONFIG_CDIO)	+= cdio.so
 ip-$(CONFIG_FLAC)	+= flac.so
 ip-$(CONFIG_MAD)	+= mad.so
 ip-$(CONFIG_MIKMOD)	+= mikmod.so
@@ -86,7 +93,9 @@
 ip-$(CONFIG_MP4)	+= mp4.so
 ip-$(CONFIG_AAC)	+= aac.so
 ip-$(CONFIG_FFMPEG)	+= ffmpeg.so
-
+ip-$(CONFIG_CUE)	+= cue.so
+
+$(cdio-objs):		CFLAGS += $(CDIO_CFLAGS) $(CDDB_CFLAGS)
 $(flac-objs):		CFLAGS += $(FLAC_CFLAGS)
 $(mad-objs):		CFLAGS += $(MAD_CFLAGS)
 $(mikmod-objs):		CFLAGS += $(MIKMOD_CFLAGS)
@@ -97,6 +106,10 @@
 $(mp4-objs):		CFLAGS += $(MP4_CFLAGS)
 $(aac-objs):		CFLAGS += $(AAC_CFLAGS)
 $(ffmpeg-objs):		CFLAGS += $(FFMPEG_CFLAGS)
+$(cue-objs):		CFLAGS += $(CUE_CFLAGS)
+
+cdio.so: $(cdio-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(CDIO_LIBS) $(CDDB_LIBS))
 
 flac.so: $(flac-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(FLAC_LIBS))
@@ -130,6 +143,9 @@
 
 ffmpeg.so: $(ffmpeg-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(FFMPEG_LIBS))
+
+cue.so: $(cue-objs) $(libcmus-y)
+	$(call cmd,ld_dl,$(CUE_LIBS))
 
 # }}}
 
@@ -211,7 +227,7 @@
 
 data		= $(wildcard data/*)
 
-clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1 Doc/*.7
+clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1 Doc/*.7 .install.log
 distclean	+= .version config.mk config/*.h tags
 
 main: cmus cmus-remote

=== debian/control ===
Source: cmus
Section: user/multimedia
Priority: extra
Maintainer: Siim Salonen <siim.salonen@gmail.com>
Build-Depends: debhelper (>= 5),
	autotools-dev,
	libcue1-dev,
	libasound2-dev (>= 1.0.11) [linux-any],
	libavformat-dev,
	libflac-dev,
	libmad0-dev,
	libmpcdec-dev,
	libncursesw5-dev,
	libvorbis-dev,
	libmodplug-dev
Standards-Version: 3.7.2

Package: cmus
Architecture: any
Depends:  ${misc:Depends}, ${shlibs:Depends}
Description: Console music player
 C* Music Player is a modular and very configurable ncurses-based audio player.
 It has some interesting features like configurable colorscheme, mp3 and ogg
 streaming, it can be controlled with an UNIX socket, filters, album/artists
 sorting and a vi-like configuration interface.
 .
 It currently supports different input formats:
  - Ogg Vorbis
  - MP3 (with libmad)
  - FLAC
  - Wav
  - Modules (with libmodplug)
  - Musepack
  - AAC
  - Windows Media Audio

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

config.status: configure
	dh_testdir
	# Add here commands to configure the package.
#	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info CFLAGS="$(CFLAGS)" LDFLAGS="-Wl,-z,defs"
	./configure host=$(DEB_HOST_GNU_TYPE) build=$(DEB_BUILD_GNU_TYPE) prefix=/usr CFLAGS="$(CFLAGS)" CONFIG_AO=n CONFIG_ROAR=n CONFIG_ARTS=n CONFIG_OSS=n


#Architecture 
build: build-arch

build-arch: build-arch-stamp
build-arch-stamp:  config.status

	# Add here commands to compile the arch part of the package.
	$(MAKE) 
	touch $@

build-indep: build-indep-stamp
build-indep-stamp:  config.status

	# Add here commands to compile the indep part of the package.
	#$(MAKE) doc
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#

	# Add here commands to clean up after the build process.
	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean 

install: install-arch
install-indep:
	dh_testdir
	dh_testroot
#	dh_clean -k -i 
	dh_prep
	dh_installdirs -i

	# Add here commands to install the indep part of the package into
	# debian/<package>-doc.
	#INSTALLDOC#

	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
#	dh_clean -k -s 
	dh_prep
	dh_installdirs -s

	# Add here commands to install the arch part of the package into 
	# debian/tmp.
	#	$(MAKE) prefix=$(CURDIR)/debian/cmus/usr install
	$(MAKE) bindir=$(CURDIR)/debian/cmus/usr/bin \
		datadir=$(CURDIR)/debian/cmus/usr/share \
		libdir=$(CURDIR)/debian/cmus/usr/lib \
		mandir=$(CURDIR)/debian/cmus/usr/share/man \
		exampledir=$(CURDIR)/debian/cmus/usr/share/doc/cmus/examples \
		install

	dh_install -s

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate	
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
#	dh_installcron
#	dh_installinfo
#	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	maemo-optify
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

#binary: binary-arch binary-indep
binary: binary-arch
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch

## cmus 2.4.1

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # SHA1
 _ver2	= $(shell git rev-parse --verify --short $(REV) 2>/dev/null)
 # hand-made
-_ver3	= v2.4.0
+_ver3	= v2.4.1
 
 VERSION	= $(or $(_ver0),$(_ver1),$(_ver2),$(_ver3))
 
@@ -18,13 +18,11 @@
 
 CFLAGS += -D_FILE_OFFSET_BITS=64
 
-CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) $(DISCID_LIBS) $(CUE_LIBS) -lm $(COMPAT_LIBS)
+CMUS_LIBS = $(PTHREAD_LIBS) $(NCURSES_LIBS) $(ICONV_LIBS) $(DL_LIBS) -lm $(COMPAT_LIBS)
 
 input.o main.o ui_curses.o pulse.lo: .version
 input.o main.o ui_curses.o pulse.lo: CFLAGS += -DVERSION=\"$(VERSION)\"
 main.o server.o: CFLAGS += -DDEFAULT_PORT=3000
-discid.o: CFLAGS += $(DISCID_CFLAGS)
-job.o cue_utils.o: CFLAGS += $(CUE_CFLAGS)
 
 .version: Makefile
 	@test "`cat $@ 2> /dev/null`" = "$(VERSION)" && exit 0; \
@@ -33,7 +31,7 @@
 # programs {{{
 cmus-y := \
 	ape.o browser.o buffer.o cache.o cmdline.o cmus.o command_mode.o comment.o \
-	channelmap.o convert.lo debug.o discid.o editable.o expr.o filters.o \
+	convert.lo debug.o editable.o expr.o filters.o \
 	format_print.o gbuf.o glob.o help.o history.o http.o id3.o input.o job.o \
 	keys.o keyval.o lib.o load_dir.o locking.o mergesort.o misc.o options.o \
 	output.o pcm.o pl.o play_queue.o player.o \
@@ -42,8 +40,6 @@
 	track.o track_info.o tree.o u_collate.o uchar.o ui_curses.o \
 	window.o worker.o xstrjoin.o
 
-cmus-$(CONFIG_CUE) += cue_utils.o
-
 $(cmus-y): CFLAGS += $(PTHREAD_CFLAGS) $(NCURSES_CFLAGS) $(ICONV_CFLAGS) $(DL_CFLAGS)
 
 cmus: $(cmus-y) file.o path.o prog.o xmalloc.o
@@ -67,7 +63,6 @@
 # }}}
 
 # input plugins {{{
-cdio-objs		:= cdio.lo
 flac-objs		:= flac.lo
 mad-objs		:= mad.lo nomad.lo
 mikmod-objs		:= mikmod.lo
@@ -79,9 +74,7 @@
 mp4-objs		:= mp4.lo
 aac-objs		:= aac.lo
 ffmpeg-objs		:= ffmpeg.lo
-cue-objs		:= cue.lo
-
-ip-$(CONFIG_CDIO)	+= cdio.so
+
 ip-$(CONFIG_FLAC)	+= flac.so
 ip-$(CONFIG_MAD)	+= mad.so
 ip-$(CONFIG_MIKMOD)	+= mikmod.so
@@ -93,9 +86,7 @@
 ip-$(CONFIG_MP4)	+= mp4.so
 ip-$(CONFIG_AAC)	+= aac.so
 ip-$(CONFIG_FFMPEG)	+= ffmpeg.so
-ip-$(CONFIG_CUE)	+= cue.so
-
-$(cdio-objs):		CFLAGS += $(CDIO_CFLAGS) $(CDDB_CFLAGS)
+
 $(flac-objs):		CFLAGS += $(FLAC_CFLAGS)
 $(mad-objs):		CFLAGS += $(MAD_CFLAGS)
 $(mikmod-objs):		CFLAGS += $(MIKMOD_CFLAGS)
@@ -106,10 +97,6 @@
 $(mp4-objs):		CFLAGS += $(MP4_CFLAGS)
 $(aac-objs):		CFLAGS += $(AAC_CFLAGS)
 $(ffmpeg-objs):		CFLAGS += $(FFMPEG_CFLAGS)
-$(cue-objs):		CFLAGS += $(CUE_CFLAGS)
-
-cdio.so: $(cdio-objs) $(libcmus-y)
-	$(call cmd,ld_dl,$(CDIO_LIBS) $(CDDB_LIBS))
 
 flac.so: $(flac-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(FLAC_LIBS))
@@ -143,9 +130,6 @@
 
 ffmpeg.so: $(ffmpeg-objs) $(libcmus-y)
 	$(call cmd,ld_dl,$(FFMPEG_LIBS))
-
-cue.so: $(cue-objs) $(libcmus-y)
-	$(call cmd,ld_dl,$(CUE_LIBS))
 
 # }}}
 
@@ -227,7 +211,7 @@
 
 data		= $(wildcard data/*)
 
-clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1 Doc/*.7 .install.log
+clean		+= *.o *.lo *.so cmus libcmus.a cmus.def cmus.base cmus.exp cmus-remote Doc/*.o Doc/ttman Doc/*.1 Doc/*.7
 distclean	+= .version config.mk config/*.h tags
 
 main: cmus cmus-remote

=== debian/changelog ===
cmus (2.4.1-1ubuntu1) oneiric; urgency=low

  * Add patch from Johannes Weißl to fix FTBFS with newest version of FFmpeg.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 01 Jun 2011 10:20:39 +0200

cmus (2.4.1-1) unstable; urgency=medium

  * New upstream release (Closes: #628422):
    - Doc: add help for :shell
    - ffmpeg: move up "config/ffmpeg.h" include
    - fix two memleaks
    - fix cache refresh bug
    - configure: fix FLAC include path
    - configure: fix ffmpeg header detection
    - fix TCP/IP networking protocol
    - fix segfault when hitting win-activate on empty tree
    - display error if seeking failed
    - fix segfault when using tqueue/lqueue
    - fix lqueue command
    - fix infinite loop when adding certain mp3 files
    - fix reading of id3v2 tags at the end of files
    - more fault-tolerant integer tag-reading
  * Bump urgency to medium as the previous release was seriously buggy.

 -- Alessio Treglia <alessio@debian.org>  Sun, 29 May 2011 19:18:48 +0200

=== debian/control ===
Source: cmus
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>,
 Ryan Kavanagh <ryanakca@kubuntu.org>
Build-Depends: debhelper (>= 7.0.50~),
 pkg-config,
 libflac-dev,
 libncursesw5-dev,
 libmodplug-dev,
 libmad0-dev,
 libvorbis-dev,
 libpulse-dev (>= 0.9.19),
 libasound2-dev (>= 1.0.11) [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386],
 libmpcdec-dev,
 libao-dev,
 libfaad-dev,
 libroar-dev (>= 0.4~beta2),
 libwavpack-dev,
 libavformat-dev
DM-Upload-Allowed: yes
Standards-Version: 3.9.2
Homepage: http://cmus.sourceforge.net/
Vcs-Git: git://git.debian.org/pkg-multimedia/cmus.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/cmus.git

Package: cmus
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Recommends: cmus-plugin-ffmpeg,
 ${shlibs:Recommends}
Description: lightweight ncurses audio player
 C* Music Player is a modular and very configurable ncurses-based audio player.
 It has some interesting features like configurable colorscheme, mp3 and ogg
 streaming, it can be controlled with an UNIX socket, filters, album/artists
 sorting and a vi-like configuration interface. 
 .
 It currently supports different input formats:
  - Ogg Vorbis
  - MP3 (with libmad)
  - FLAC
  - Wav
  - Modules (with libmodplug)
  - Musepack
  - AAC
  - Windows Media Audio

Package: cmus-plugin-ffmpeg
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: cmus
Description: lightweight ncurses audio player (FFmpeg plugin)
 C* Music Player is a modular and very configurable ncurses-based audio player.
 It has some interesting features like configurable colorscheme, mp3 and ogg
 streaming, it can be controlled with an UNIX socket, filters, album/artists
 sorting and a vi-like configuration interface.
 .
 This package adds FFmpeg support to C* Music Player.
